/* sockets_test.c -- test harness for sockets.c and sockets.h */

#include "cmd_sockets.h"
#include <stdio.h>
#include <string.h>

void exit(int return_code);

static unsigned int counter = 0;				 /* this counts to prove we are not blocking */

void update_counter(void) {					 /* the non-i/o task */
  counter++;							 /* keep the counter moving */
}


int main(int nargs, char* arg[]) {				 /* demonstration of non-blocking read of sdtin */
  char* bfr;
  printf("Starting up, counter = %d\n", counter);

  for(;;) {							 /* loop until an exit condition occurs */

    update_counter();						 /* run the non-i/o task */

    bfr = enquiry();						 /* try to get an input line */

    if ((int)bfr == EOF) {					 /* end of file? */
      response("end of file detected!\n");
      exit(0);
    }

    if (bfr != NULL) {						 /* got one? */
      if (strcmp(bfr, "exit\n") == 0) {				 /* yes, was it an exit command? */

	sprintf(bfr, "Exiting, counter = %d\n", counter);	 /* yes, say we are exiting */
	response(bfr);
	
	exit(0);						 /* and then exit */
      }
      sprintf(bfr, "%s:counter = %d\n", bfr, counter);		 /* not exit command, so just echo it */
      response(bfr);
    }
  }
}
